#include <bindings.macros.h>
#include <math.h>

-- | <http://www.opengroup.org/onlinepubs/9699919799/basedefs/math.h.html>

module Bindings.C.Math where
import Foreign
import Foreign.C

#num FP_INFINITE
#num FP_NAN
#num FP_NORMAL
#num FP_SUBNORMAL
#num FP_ZERO
#num FP_ILOGB0
#num FP_ILOGBNAN
#num MATH_ERRNO
#num MATH_ERREXCEPT

#ccall acos , CDouble -> IO CDouble
#ccall acosf , CFloat -> IO CFloat 
#ccall acosh , CDouble -> IO CDouble 
#ccall acoshf , CFloat -> IO CFloat 
#ccall acoshl , CLDouble -> IO CLDouble
#ccall acosl , CLDouble -> IO CLDouble
#ccall asin , CDouble -> IO CDouble 
#ccall asinf , CFloat -> IO CFloat 
#ccall asinh , CDouble -> IO CDouble 
#ccall asinhf , CFloat -> IO CFloat 
#ccall asinhl , CLDouble -> IO CLDouble
#ccall asinl , CLDouble -> IO CLDouble
#ccall atan , CDouble -> IO CDouble 
#ccall atan2 , CDouble -> CDouble -> IO CDouble 
#ccall atan2f , CFloat -> CFloat -> IO CFloat 
#ccall atan2l , CLDouble -> CLDouble -> IO CLDouble
#ccall atanf , CFloat -> IO CFloat 
#ccall atanh , CDouble -> IO CDouble 
#ccall atanhf , CFloat -> IO CFloat 
#ccall atanhl , CLDouble -> IO CLDouble
#ccall atanl , CLDouble -> IO CLDouble
#ccall cbrt , CDouble -> IO CDouble 
#ccall cbrtf , CFloat -> IO CFloat 
#ccall cbrtl , CLDouble -> IO CLDouble
#ccall ceil , CDouble -> IO CDouble 
#ccall ceilf , CFloat -> IO CFloat 
#ccall ceill , CLDouble -> IO CLDouble
#ccall copysign , CDouble -> CDouble -> IO CDouble 
#ccall copysignf , CFloat -> CFloat -> IO CFloat 
#ccall copysignl , CLDouble -> CLDouble -> IO CLDouble
#ccall cos , CDouble -> IO CDouble 
#ccall cosf , CFloat -> IO CFloat 
#ccall cosh , CDouble -> IO CDouble 
#ccall coshf , CFloat -> IO CFloat 
#ccall coshl , CLDouble -> IO CLDouble
#ccall cosl , CLDouble -> IO CLDouble
#ccall erf , CDouble -> IO CDouble 
#ccall erfc , CDouble -> IO CDouble 
#ccall erfcf , CFloat -> IO CFloat 
#ccall erfcl , CLDouble -> IO CLDouble
#ccall erff , CFloat -> IO CFloat 
#ccall erfl , CLDouble -> IO CLDouble
#ccall exp , CDouble -> IO CDouble 
#ccall exp2 , CDouble -> IO CDouble 
#ccall exp2f , CFloat -> IO CFloat 
#ccall exp2l , CLDouble -> IO CLDouble
#ccall expf , CFloat -> IO CFloat 
#ccall expl , CLDouble -> IO CLDouble
#ccall expm1 , CDouble -> IO CDouble 
#ccall expm1f , CFloat -> IO CFloat 
#ccall expm1l , CLDouble -> IO CLDouble
#ccall fabs , CDouble -> IO CDouble 
#ccall fabsf , CFloat -> IO CFloat 
#ccall fabsl , CLDouble -> IO CLDouble
#ccall fdim , CDouble -> CDouble -> IO CDouble 
#ccall fdimf , CFloat -> CFloat -> IO CFloat 
#ccall fdiml , CLDouble -> CLDouble -> IO CLDouble
#ccall floor , CDouble -> IO CDouble 
#ccall floorf , CFloat -> IO CFloat 
#ccall floorl , CLDouble -> IO CLDouble
#ccall fma , CDouble -> CDouble -> CDouble -> IO CDouble 
#ccall fmaf , CFloat -> CFloat -> CFloat -> IO CFloat 
#ccall fmal , CLDouble -> CLDouble -> CLDouble -> IO CLDouble
#ccall fmax , CDouble -> CDouble -> IO CDouble 
#ccall fmaxf , CFloat -> CFloat -> IO CFloat 
#ccall fmaxl , CLDouble -> CLDouble -> IO CLDouble
#ccall fmin , CDouble -> CDouble -> IO CDouble 
#ccall fminf , CFloat -> CFloat -> IO CFloat 
#ccall fminl , CLDouble -> CLDouble -> IO CLDouble
#ccall fmod , CDouble -> CDouble -> IO CDouble 
#ccall fmodf , CFloat -> CFloat -> IO CFloat 
#ccall fmodl , CLDouble -> CLDouble -> IO CLDouble
#ccall frexp , CDouble -> Ptr CInt -> IO CDouble 
#ccall frexpf , CFloat -> Ptr CInt -> IO CFloat 
#ccall frexpl , CLDouble -> Ptr CInt -> IO CLDouble
#ccall hypot , CDouble -> CDouble -> IO CDouble 
#ccall hypotf , CFloat -> CFloat -> IO CFloat 
#ccall hypotl , CLDouble -> CLDouble -> IO CLDouble
#ccall ilogb , CDouble -> IO CInt 
#ccall ilogbf , CFloat -> IO CInt 
#ccall ilogbl , CLDouble -> IO CInt 
#ccall ldexp , CDouble -> CInt -> IO CDouble 
#ccall ldexpf , CFloat -> CInt -> IO CFloat 
#ccall ldexpl , CLDouble -> CInt -> IO CLDouble
#ccall lgamma , CDouble -> IO CDouble 
#ccall lgammaf , CFloat -> IO CFloat 
#ccall lgammal , CLDouble -> IO CLDouble
#ccall llrint , CDouble -> IO CLLong 
#ccall llrintf , CFloat -> IO CLLong 
#ccall llrintl , CLDouble -> IO CLLong 
#ccall llround , CDouble -> IO CLLong 
#ccall llroundf , CFloat -> IO CLLong 
#ccall llroundl , CLDouble -> IO CLLong 
#ccall log , CDouble -> IO CDouble 
#ccall log10 , CDouble -> IO CDouble 
#ccall log10f , CFloat -> IO CFloat 
#ccall log10l , CLDouble -> IO CLDouble
#ccall log1p , CDouble -> IO CDouble 
#ccall log1pf , CFloat -> IO CFloat 
#ccall log1pl , CLDouble -> IO CLDouble
#ccall log2 , CDouble -> IO CDouble 
#ccall log2f , CFloat -> IO CFloat 
#ccall log2l , CLDouble -> IO CLDouble
#ccall logb , CDouble -> IO CDouble 
#ccall logbf , CFloat -> IO CFloat 
#ccall logbl , CLDouble -> IO CLDouble
#ccall logf , CFloat -> IO CFloat 
#ccall logl , CLDouble -> IO CLDouble
#ccall lrint , CDouble -> IO CLong 
#ccall lrintf , CFloat -> IO CLong 
#ccall lrintl , CLDouble -> IO CLong 
#ccall lround , CDouble -> IO CLong 
#ccall lroundf , CFloat -> IO CLong 
#ccall lroundl , CLDouble -> IO CLong 
#ccall modf , CDouble -> Ptr CDouble -> IO CDouble 
#ccall modff , CFloat -> Ptr CFloat -> IO CFloat 
#ccall modfl , CLDouble -> Ptr CLDouble -> IO CLDouble
#ccall nan , CString -> IO CDouble 
#ccall nanf , CString -> IO CFloat 
#ccall nanl , CString -> IO CLDouble
#ccall nearbyint , CDouble -> IO CDouble 
#ccall nearbyintf , CFloat -> IO CFloat 
#ccall nearbyintl , CLDouble -> IO CLDouble
#ccall nextafter , CDouble -> CDouble -> IO CDouble 
#ccall nextafterf , CFloat -> CFloat -> IO CFloat 
#ccall nextafterl , CLDouble -> CLDouble -> IO CLDouble
#ccall nexttoward , CDouble -> CLDouble -> IO CDouble 
#ccall nexttowardf , CFloat -> CLDouble -> IO CFloat 
#ccall nexttowardl , CLDouble -> CLDouble -> IO CLDouble
#ccall pow , CDouble -> CDouble -> IO CDouble 
#ccall powf , CFloat -> CFloat -> IO CFloat 
#ccall powl , CLDouble -> CLDouble -> IO CLDouble
#ccall remainder , CDouble -> CDouble -> IO CDouble 
#ccall remainderf , CFloat -> CFloat -> IO CFloat 
#ccall remainderl , CLDouble -> CLDouble -> IO CLDouble
#ccall remquo , CDouble -> CDouble -> Ptr CInt -> IO CDouble 
#ccall remquof , CFloat -> CFloat -> Ptr CInt -> IO CFloat 
#ccall remquol , CLDouble -> CLDouble -> Ptr CInt -> IO CLDouble
#ccall rint , CDouble -> IO CDouble 
#ccall rintf , CFloat -> IO CFloat 
#ccall rintl , CLDouble -> IO CLDouble
#ccall round , CDouble -> IO CDouble 
#ccall roundf , CFloat -> IO CFloat 
#ccall roundl , CLDouble -> IO CLDouble
#ccall scalbln , CDouble -> CLong -> IO CDouble 
#ccall scalblnf , CFloat -> CLong -> IO CFloat 
#ccall scalblnl , CLDouble -> CLong -> IO CLDouble
#ccall scalbn , CDouble -> CInt -> IO CDouble 
#ccall scalbnf , CFloat -> CInt -> IO CFloat 
#ccall scalbnl , CLDouble -> CInt -> IO CLDouble
#ccall sin , CDouble -> IO CDouble 
#ccall sinf , CFloat -> IO CFloat 
#ccall sinh , CDouble -> IO CDouble 
#ccall sinhf , CFloat -> IO CFloat 
#ccall sinhl , CLDouble -> IO CLDouble
#ccall sinl , CLDouble -> IO CLDouble
#ccall sqrt , CDouble -> IO CDouble 
#ccall sqrtf , CFloat -> IO CFloat 
#ccall sqrtl , CLDouble -> IO CLDouble
#ccall tan , CDouble -> IO CDouble 
#ccall tanf , CFloat -> IO CFloat 
#ccall tanh , CDouble -> IO CDouble 
#ccall tanhf , CFloat -> IO CFloat 
#ccall tanhl , CLDouble -> IO CLDouble
#ccall tanl , CLDouble -> IO CLDouble
#ccall tgamma , CDouble -> IO CDouble 
#ccall tgammaf , CFloat -> IO CFloat 
#ccall tgammal , CLDouble -> IO CLDouble
#ccall trunc , CDouble -> IO CDouble 
#ccall truncf , CFloat -> IO CFloat 
#ccall truncl , CLDouble -> IO CLDouble
