
#define bc_varid(name) printf("c'%s",(name)) \

#define bc_conid(name) \
    { \
     char buffer[strlen(name)+1]; \
     strcpy(buffer,name); \
     char *p, *q; \
     p = strtok(buffer," "); \
     while (q = strtok(NULL," ")) p = q; \
     printf("C'%s",p); \
    } \

#define bc_ptrid(name) printf("p'%s",(name)) \

#define bc_wrapper(name) printf("mk'%s",(name)) \

#define bc_fieldname(type,field) \
    { \
     char buffer[strlen(type)+1]; \
     strcpy(buffer,type); \
     char *p = buffer; \
     char *q = strtok(p," "); \
     while (q = strtok(NULL," ")) p = q; \
     printf("%s'%s",p,field); \
    } \

#define bc_decimal(name) (name) > 0 \
    ? printf("%ju",(uintmax_t)(name)) \
    : printf("%jd",(intmax_t)(name)) \

#define bc_float(name) printf("%Le",(long double)(name)) \

#define bc_typemarkup(name) \
    { \
     char buffer[strlen(name)+1]; \
     strcpy(buffer,name); \
     char *p1,*p2,*p3; \
     p1 = buffer; \
     while (*p1) \
        { \
         for (p2=p1;*p2 && *p2!='<';p2++); \
         for (p3=p2;*p3 && *p3!='>';p3++); \
         if (*p2 == '<') *p2++ = '\0'; \
         if (*p3 == '>') *p3++ = '\0'; \
         printf("%s",p1); \
         if (*p2) bc_conid(p2); \
         p1 = p3; \
        } \
    } \

#define hsc_num(name) \
    bc_varid(# name);printf(" = ");bc_decimal(name);printf("\n"); \
    bc_varid(# name);printf(" :: (Num a) => a\n"); \

#define hsc_fractional(name) \
    bc_varid(# name);printf(" = ");bc_float(name);printf("\n"); \
    bc_varid(# name);printf(" :: (Fractional a) => a\n"); \

#define hsc_pointer(name) \
    bc_varid(# name);printf(" = wordPtrToPtr %zu\n",(size_t)(name)); \
    bc_varid(# name);printf(" :: Ptr a\n"); \

#define hsc_ccall(name,type) \
    printf("foreign import ccall \"%s\" ",# name); \
    bc_varid(# name);printf("\n"); \
    printf("  :: ");bc_typemarkup(# type);printf("\n"); \
    printf("foreign import ccall \"&%s\" ",# name); \
    bc_ptrid(# name);printf("\n"); \
    printf("  :: FunPtr (");bc_typemarkup(# type);printf(")\n"); \

#define hsc_cinline(name,type) \
    printf("foreign import ccall \"inline_%s\" ",# name); \
    bc_varid(# name);printf("\n"); \
    printf("  :: ");bc_typemarkup(# type);printf("\n"); \

#define hsc_globalvar(name,type) \
    printf("foreign import ccall \"&%s\" ",# name); \
    bc_ptrid(# name);printf("\n"); \
    printf("  :: Ptr (");bc_typemarkup(# type);printf(")\n"); \

#define hsc_integral_t(name) \
    printf("type ");bc_conid(# name);printf(" = "); \
    printf("%s%zu\n",(name)(-1)<0?"Int":"Word",8*sizeof(name)); \

#define hsc_opaque_t(name) \
    printf("data ");bc_conid(# name); \
    printf(" = "); \
    bc_conid(# name);printf("\n"); \

#define hsc_callback(name,type) \
    printf("type ");bc_conid(# name); \
    printf(" = FunPtr ("); \
    bc_typemarkup(# type);printf(")\n"); \
    printf("foreign import ccall \"wrapper\" "); \
    bc_wrapper(# name); \
    printf("\n"); \
    printf("  :: ("); \
    bc_typemarkup(# type); \
    printf(") -> IO "); \
    bc_conid(# name); \
    printf("\n"); \

#define hsc_starttype(name) \
    { \
     name *refpointer = 0; \
     struct {int n, k[500]; size_t s[500], o[500];} f; \
     f.n = 0; \
     printf("data ");bc_conid(# name);printf(" = "); \
     bc_conid(# name);printf("{"); \
     char typename[] = # name; \
     size_t typesize = sizeof(name); \

#define bc_prefield(name,type,typeofarray) \
     if (f.n > 0) printf(","); \
     printf("\n  "); \
     bc_fieldname(typename,# name); \
     printf(" :: ");bc_typemarkup(# type); \
     f.k[f.n] = typeofarray; \
     f.o[f.n] = (size_t)&(refpointer->name); \

#define bc_posfield \
     f.n++; \

#define hsc_field(name,type) \
     bc_prefield(name,type,(-1)); \
     bc_posfield; \

#define hsc_array_field(name,type) \
     bc_prefield(name,[type],1); \
     f.s[f.n] = sizeof(refpointer->name); \
     f.s[f.n] /= sizeof(refpointer->name[0]); \
     bc_posfield; \

#define hsc_flexible_array_member(name,type) \
     bc_prefield(name,[type],0); \
     bc_posfield; \

#define hsc_stoptype(dummy) \
     printf("\n } deriving (Eq,Show)\n"); \
     printf("instance Storable "); \
     bc_conid(typename);printf(" where\n"); \
     printf("  sizeOf _ = %zu\n  alignment = sizeOf\n",typesize); \
     printf("  peek p = do\n"); \
     int i; \
     for (i=0;i<f.n;i++) \
        { \
         printf("    v%d <- ",i); \
         if (f.k[i] < 0) \
            printf("peekByteOff p %zu",f.o[i]); \
         if (f.k[i] > 0) \
            printf("peekArray %zu (plusPtr p %zu)",f.s[i],f.o[i]); \
         if (f.k[i] == 0) \
            printf("return []"); \
         printf("\n"); \
        } \
     printf("    return $ ");bc_conid(typename); \
     for (i=0;i<f.n;i++) printf(" v%d",i); printf("\n"); \
     printf("  poke p (");bc_conid(typename); \
     for (i=0;i<f.n;i++) printf(" v%d",i); printf(") = do\n"); \
     for (i=0;i<f.n;i++) \
        { \
         printf("    "); \
         if (f.k[i] < 0) \
            printf("pokeByteOff p %zu v%d",f.o[i],i); \
         if (f.k[i] > 0) \
            printf("pokeArray (plusPtr p %zu) " \
              "(take %zu v%d)",f.o[i],f.s[i],i); \
         if (f.k[i] == 0) \
            printf("pokeArray (plusPtr p %zu) v%d",f.o[i],i); \
         printf("\n"); \
        } \
     printf("    return ()\n"); \
    } \

